package provide tclcron::tclcron_combine 1.0

namespace eval tclcron {}
namespace eval tclcron::combine {}

proc tclcron::combine::initialize {idx params} {
    set nparams [list]
    foreach type $params {
	lappend nparams [lindex $type 0] [lrange $type 1 end]
    }
    foreach {type params} $nparams {
	package require tclcron::tclcron_$type
    }
    return $nparams
}

proc tclcron::combine::schedulenext {argsvar clock} {
    upvar $argsvar ar

    incr clock -1
    foreach increment {
	1 2 5 10 60 300 600 1200 1800 2400 3600
	7200 14400 21600 43200 86400 129600 172800
	259200 345600 432000 518400 604800 691200
	777600 864000 950400 1036800 1123200 1209600
	1814400 2419200 3024000 3628800 5184000
	7776000 10368000 12960000 15552000 18144000
	20736000 23328000 25920000 28512000 31104000
	31536000 31622400 31968000
    } {
	set clk [expr {$clock + $increment}]
	set idx -1
	foreach {type params} $ar {
	    incr idx
	    set next [tclcron::${type}::schedulenext params $clk]
	    #puts "Schedule $params: $next"
	    if {($next == "") || ($next < $clock)} {
		continue
	    }
	    if {(![info exists minnext]) || ($minnext > $next)} {
		set minval $params
		set minidx $idx
		set minnext $next
	    }
	}
    }
    
    if {[info exists minnext]} {
	#puts "$minidx -> $minval"
	lset ar [expr {$minidx * 2 + 1}] $minval
	return $minnext
    }
    
    return ""
}
